
#
# Clean Java sources
#	This macro cleans the Java sources
#
#
# Author:	Modeliosoft
#
# Applicable on: project
#
# Version history:
# 1.0	 9TH July	 - creation
#
#

import os
import stat

###############################################
# getJavaElements
#
# parameter:
#			root of the tree
#
# return:
#			the list of all children model elements (recursively) except ramcs
def getJavaElements(root):
	listEl = []
	for i in root.getOwnedElement():
		if i.getElementStatus().isRamcObject() == False:
			# recursivity
			for el in getJavaElements(i):
				listEl.append(el)

			# add files only for Java elements
			if i.isStereotyped("JavaAnnotation") or\
				i.isStereotyped("JavaClass") or\
				i.isStereotyped("JavaDataType") or\
				i.isStereotyped("JavaEnumeration") or\
				i.isStereotyped("JavaInterface"):
				listEl.append(i)

	return listEl

###############################################
# deleteFile
#
# parameter:
#			full path  name (String)
#
def deleteFile(file2rm):
	if os.path.exists (file2rm) and os.path.isfile(file2rm):
		os.chmod(file2rm, stat.S_IWRITE | stat.S_IRUSR | stat.S_IXUSR)
		try:
			os.remove(file2rm)
			return 1
		except:
			'''print "	/!\\ source files have NOT been deleted: ", file2rm'''
	return 0

###############################################
# Begin
###############################################
javaMdac = None
for module in modelingSession.getAllPeerMdacs():
	if (module.getName() == "JavaDesigner"):
		javaMdac = module;
		break;

if javaMdac is None :
	print "No Java Designer module found in the project"
else:
	print "Java source cleaning with " + javaMdac.getName() + " " +	javaMdac.getVersion().toString()
	
	cpt = 0
	for i in getJavaElements( modelingSession.getModel().getRoot() ):
		cpt += deleteFile(javaMdac.getFilename(i).toString())
		
	if cpt>1:
		print cpt, "files deleted"
	elif cpt==1:
		print cpt, "file deleted"
	else:
		print "no file deleted"

