#
# Generate JavaDoc	1.0
#	This macro runs a JavaDoc generation on the project
#
#
# Author:	Modeliosoft
#
# Applicable on:
#
# Version history:
# 1.0	 25th April 2012	 - creation
#
#

# Get the Java module peer mdac
javaMdac = None
for module in modelingSession.getAllPeerMdacs():
	if (module.getName() == "JavaDesigner"):
		javaMdac = module
		break

if javaMdac is None :
	print "No Java Designer module found in the project"
else:
	print "JavaDoc generation with " + javaMdac.getName() + " " +	javaMdac.getVersion().toString()
	
	t = modelingSession.createTransaction("Generate JavaDoc")

	# save current value for "AutomaticallyOpenJavadoc" parameter
	savedAutoOpen = javaMdac.getConfiguration().getParameterValue("AutomaticallyOpenJavadoc")
	javaMdac.getConfiguration().setParameterValue("AutomaticallyOpenJavadoc", "false")
	  
	# generate the root package
	javaMdac.generateJavaDoc(modelingSession.getModel().getRoot(), False)
	
	# restore "AutomaticallyOpenJavadoc" parameter value
	javaMdac.getConfiguration().setParameterValue("AutomaticallyOpenJavadoc", savedAutoOpen)
	
	modelingSession.rollback(t)
