#
# Generate Java	Sources 1.0
#	This macro runs a Java code generation on the project
#
#
# Author:	Modeliosoft
#
# Applicable on:
#
# Version history:
# 1.0	 25th April 2012	 - creation
#
#

# Get the Java module peer mdac
javaMdac = None
for module in modelingSession.getAllPeerMdacs():
	if (module.getName() == "JavaDesigner"):
		javaMdac = module
		break

if javaMdac is None :
	print "No Java Designer module found in the project"
else:
	print "Java source generation with " + javaMdac.getName() + " " +	javaMdac.getVersion().toString()
	
	t = modelingSession.createTransaction("Generate sources")
	
	# save current value for "default retrieve mode" parameter
	savedRetrieveMode = javaMdac.getConfiguration().getParameterValue("RetrieveDefaultBehaviour")
	javaMdac.getConfiguration().setParameterValue("RetrieveDefaultBehaviour", "Keep")
	
	# generate the root package
	javaMdac.generate(modelingSession.getModel().getRoot(), False)
	
	# restore "default retrieve mode" parameter value
	javaMdac.getConfiguration().setParameterValue("RetrieveDefaultBehaviour", savedRetrieveMode)
	
	modelingSession.rollback(t)
	