#
# Generate JavaDoc	1.0
#	This macro runs an SVN update on the project
#
#
# Author:	Modeliosoft
#
# Applicable on:
#
# Version history:
# 1.0	 25th April 2012	 - creation
#
#

# Get the Subversion module peer mdac
svnMdac = None
for module in modelingSession.getAllPeerMdacs():
        if (module.getName() == "Subversion"):
                svnMdac = module;
                break;

if svnMdac is None :
        print "No Subversion module found in the project"
else:
        print "SVN Update ", svnMdac.getName(),  svnMdac.getVersion()
        
        from com.modeliosoft.subversion.api import UpdateParameters
        
        elements=[modelingSession.getModel().getRoot()]

        transaction = modelingSession.createTransaction("SVN update")

        # Save module parameters
        oldConfirmRamcUpdate = svnMdac.getConfiguration().getParameterValue("confirmRamcUpdate")
        oldConfirmModulesUpdate = svnMdac.getConfiguration().getParameterValue("confirmModulesUpdate")

        # Set confirmations to false
        svnMdac.getConfiguration().setParameterValue("confirmRamcUpdate", "False")
        svnMdac.getConfiguration().setParameterValue("confirmModulesUpdate", "False")

        updateParameters = UpdateParameters(elements, UpdateParameters.ImportDepth.SMART)
        results = svnMdac.update(updateParameters, None)
        for e in results.getCreatedElements():
                print "+", e
        for e in results.getDeletedElements():
                print "-", e
        for e in results.getUpdatedElements():
                print "*", e
                
        # Reset module parameters
        svnMdac.getConfiguration().setParameterValue("confirmRamcUpdate", oldConfirmRamcUpdate)
        svnMdac.getConfiguration().setParameterValue("confirmModulesUpdate", oldConfirmModulesUpdate)
        
        modelingSession.commit(transaction)
        modelingSession.save()
